package com.sd.cavphmi.ui

import android.content.DialogInterface
import android.view.KeyEvent
import androidx.appcompat.app.AlertDialog
import androidx.lifecycle.ViewModelProvider
import com.sd.cavphmi.BR
import com.sd.cavphmi.R
import com.sd.cavphmi.base.BaseActivity
import com.sd.cavphmi.base.MyBaseViewModel
import com.sd.cavphmi.databinding.ActivityMainBinding
import com.sd.cavphmi.viewmodels.MainVm
import dagger.hilt.android.AndroidEntryPoint

@AndroidEntryPoint
class MainActivity : BaseActivity<ActivityMainBinding, MainVm>() {

    override fun getStatuBarColor(): Int {
        return -1
    }


    override fun initContentView(): Int {
        return R.layout.activity_main
    }

    override fun initViewModel(): MainVm {
        return ViewModelProvider(this).get(MainVm::class.java)
    }

    override fun initVariableId(): Int {
        return BR.vm
    }


    override fun initView() {
//        viewModel.showVToTip()
        viewModel.startWS()

    }

    override fun getToData() {

    }

    override fun dispatchKeyEvent(event: KeyEvent): Boolean {
        if ((event.getKeyCode() == KeyEvent.KEYCODE_BACK) || event.getKeyCode() == KeyEvent.KEYCODE_HOME) {
                //如果是导航中，提示清除资源
                val dialog = AlertDialog.Builder(this)
//                dialog.setIcon(android.R.drawable.ic_dialog_info)
                dialog.setTitle("提示")
                dialog.setMessage("确定退出应用")
                dialog.setPositiveButton(
                    "确定",
                    DialogInterface.OnClickListener { dialog1: DialogInterface?, which: Int ->
                        viewModel.closeWS()
                        finish()
                    })
                dialog.setNegativeButton(
                    "取消",
                    DialogInterface.OnClickListener { dialog12: DialogInterface?, which: Int -> })
                dialog.show()

            return true
        } else {
            return super.dispatchKeyEvent(event)
        }
    }


}