package com.sd.cavphmi.utils

import androidx.security.crypto.EncryptedSharedPreferences
import com.sd.cavphmi.MyAppcation


object MyPres {

    private const val PREFS_NAME = "adas"
    private const val MASTER_KEY_ALIAS = "masterkeyalias"

    private val sharedPreferences by lazy {
        EncryptedSharedPreferences.create(
            PREFS_NAME,
            MASTER_KEY_ALIAS,
            MyAppcation.instance().applicationContext,
            EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
            EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
        )
    }

    var token: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("token", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("token", "") ?: ""
        }

    var hisSearch: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("hisSearch", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("hisSearch", "") ?: ""
        }

    /**
     * 全类型历史搜素
     */
    var curLat: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("curLat", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("curLat", "") ?: ""
        }

    /**
     * 专题资料历史搜素
     */
    var curLng: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("curLng", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("curLng", "") ?: ""
        }

    /**
     * 资料历史搜素
     */
    var dataSearch: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("dataSearch", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("dataSearch", "") ?: ""
        }

    /**
     * 问答历史搜素
     */
    var qaSearch: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("qaSearch", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("qaSearch", "") ?: ""
        }

    /**
     * 首次授权
     */
    var isFrist: Boolean
        set(value) {
            with(sharedPreferences.edit()) {
                putBoolean("isFrist", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getBoolean("isFrist", true)
        }

    /**
     * 邀请码
     */
    var invCode: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("invcode", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("invcode", "") ?: ""

        }

    /**
     * 个人电话
     */
    var mobile: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("mobile", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("mobile", "") ?: ""
        }

    /**
     * 删除领域
     */
    var goodField: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("goodField", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("goodField", "") ?: ""
        }

    var userId: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("userId", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("userId", "") ?: ""
        }

    /**
     * 极光推送ID
     */
    var registrationId: String
        set(value) {
            with(sharedPreferences.edit()) {
                putString("registrationId", value)
                commit()
            }
        }
        get() {
            return sharedPreferences.getString("registrationId", "") ?: ""
        }


}