package com.sd.cavphmi.viewmodels

import android.content.Context
import androidx.lifecycle.viewModelScope
import com.google.gson.Gson
import com.sd.cavphmi.base.MyBaseViewModel
import com.sd.cavphmi.bean.ReqBean
import com.sd.cavphmi.bean.SpaceNoBean
import com.sd.cavphmi.bean.VToXImgBean
import com.sd.cavphmi.bean.WebSetBean
import com.sd.cavphmi.net.MyResult
import com.sd.cavphmi.repositorys.SpaceNoRepo
import com.sd.cavphmi.utils.MyContants
import com.sd.cavphmi.utils.ToastHelper
import com.sd.cavphmi.websockets.MyWebSocketClient
import dagger.hilt.android.lifecycle.HiltViewModel
import dagger.hilt.android.qualifiers.ApplicationContext
import kotlinx.coroutines.launch
import org.java_websocket.handshake.ServerHandshake
import java.net.URI
import java.nio.ByteBuffer
import javax.inject.Inject


@HiltViewModel
class MainVm @Inject constructor(
    @ApplicationContext var context: Context,
    var spaceNoRepo: SpaceNoRepo
) : MyBaseViewModel() {

    private var client: MyWebSocketClient? = null

    private var gson = Gson()

    fun startWS() {
        val httpHeaders = mutableMapOf<String, String>()
        httpHeaders.put("Cookie", "username=nemo")

        try {
            client = MyWebSocketClient(URI(MyContants.WS_HOST))
            client?.onSocketCb = onSocketCb
            client?.connect()
        } catch (e: Exception) {

        }
    }

    fun closeWS() {
        if (client?.isOpen ?: false) {
            client?.close()
        }
    }

    var onSocketCb = object : MyWebSocketClient.OnSocketCb {
        override fun onOpen(handshakedata: ServerHandshake?) {
            println("--------Thread.currentThread() = ${Thread.currentThread()}")
            subVehicle()
        }

        override fun onMessage(message: String?) {
        }

        override fun onMessage(bytes: ByteBuffer?) {

        }

        override fun onClose(code: Int, reason: String?, remote: Boolean) {
        }

        override fun onError(ex: Exception?) {
        }

    }

    /*** 2.2. 联网车辆位姿数据topic**/
    fun subVehicle() {
        var reqStr = getSendData("/topic/vehicle")
        client?.send(reqStr)
    }

    fun getSendData(key: String): String {
        var data = WebSetBean.dic.get(key)
        var req = ReqBean()
        req.data = data!!
        var str = gson.toJson(req)
        return str
    }


    fun showVToTip() {
        var imgs = VToXImgBean.imgs
        ToastHelper.showCustViewShort(context, imgs.get("2")!!)
    }

    fun getSpaceData() {
        viewModelScope.launch {
            var result = spaceNoRepo.getSpaceData()
            when (result) {
                is MyResult.Success<SpaceNoBean> -> {
                    var a = 0
                }

                else -> {
                    var b = 0
                }
            }
        }
    }


}