package com.sd.cavphmi.websockets

import org.java_websocket.client.WebSocketClient
import org.java_websocket.drafts.Draft
import org.java_websocket.handshake.ServerHandshake
import java.net.URI
import java.nio.ByteBuffer

class MyWebSocketClient : WebSocketClient {

    val TAG = "-----MyWebSocketClient"

    constructor(serverUri: URI?) : super(serverUri)

    constructor(serverUri: URI?, protocolDraft: Draft?) : super(serverUri, protocolDraft)

    constructor(serverUri: URI?, httpHeaders: MutableMap<String, String>?) : super(
        serverUri,
        httpHeaders
    )


    override fun onOpen(handshakedata: ServerHandshake?) {
//        send("Hello, it is me. Mario :)")
        System.out.println(TAG + "new connection opened")
        onSocketCb?.onOpen(handshakedata)
    }

    override fun onMessage(message: String?) {
        System.out.println(TAG + "received message: " + message);

        onSocketCb?.onMessage(message)
        //处理各种推送消息
//        let data = {};
//        let result = await decodeResponseProtoBuf(msg);
//        // console.log(result);
//
//        // 抹平与之前推送数据接口的差异
//        data.body = result.data;
//        const eventName = this.dic[result.msgType].action;
//
//        //执行回调
//        // this.messageList[eventName](data);
//        if (this.messageList[eventName]) {
//            //执行回调
//            this.messageList[eventName](data);
//        }
    }

    override fun onMessage(bytes: ByteBuffer?) {
        System.out.println(TAG + "  received ByteBuffer")
        onSocketCb?.onMessage(bytes)
    }

    override fun onClose(code: Int, reason: String?, remote: Boolean) {
        System.out.println(TAG + "  closed with exit code " + code + " additional info: " + reason);
        onSocketCb?.onClose(code,reason,remote)
    }

    override fun onError(ex: Exception?) {
        System.err.println(TAG + "an error occurred:" + ex);
        onSocketCb?.onError(ex)
    }

    var onSocketCb: OnSocketCb? = null

    interface OnSocketCb {
        fun onOpen(handshakedata: ServerHandshake?)
        fun onMessage(message: String?)
        fun onMessage(bytes: ByteBuffer?)
        fun onClose(code: Int, reason: String?, remote: Boolean)
        fun onError(ex: Exception?)
    }


}